
require "native_bit"

local mPhotonView,mJavaBridge = ...
local cutflag
local mInitedGameList = false
local mSelectGamedialog = nil
local PLAYING_GAME_LIST_SORT_KEY =  "PLAYING_GAME_LIST_SORT"
local mPlayingGameListSort = nil


function init()
	cutflag = true
    set_flat_bar(true)
end

function clickExpand()
	local binder = mPhotonView:getParser():getBinder()

	if( cutflag ) then
		mPhotonView:getParser():getChildView("description_txt"):getParser():update("cutflag","false")
        if(binder ~= nil and binder:get('versionName') ~= nil and binder:get('versionName') ~="")then
            mPhotonView:getParser():getChildView("version_num"):getParser():update("visibility","visible")
        end
        if(binder ~= nil and binder:get('uptimeStr') ~= nil and binder:get('uptimeStr') ~="")then
            mPhotonView:getParser():getChildView("update_time"):getParser():update("visibility","visible")
        end
        if(binder ~= nil and binder:get('author') ~= nil and binder:get('author') ~="")then
            mPhotonView:getParser():getChildView("author_title"):getParser():update("visibility","visible")
        end
        if(binder ~= nil and binder:get('permissions') ~= nil and binder:get('permissions') ~="")then
            mPhotonView:getParser():getChildView("permission_info"):getParser():update("visibility","visible")
            mPhotonView:getParser():getChildView("permission_link"):getParser():update("visibility","visible")
        end
        mPhotonView:getParser():getChildView("expand_shader"):getParser():update("visibility","gone")
        mPhotonView:getParser():getChildView("expand_icon"):getParser():update("alignparentbottom","true")

        if(binder ~= nil and binder:get('arrow_close_url') ~= nil and binder:get('arrow_close_url') ~="")then
            mPhotonView:getParser():getChildView("expand_icon"):getParser():update("url","data@arrow_close_url")
        else
            mPhotonView:getParser():getChildView("expand_icon"):getParser():update("image","res@icon_close")
        end

		showFlagView()
		cutflag = false
	else
		mPhotonView:getParser():getChildView("description_txt"):getParser():update("cutflag","true")
		mPhotonView:getParser():getChildView("version_num"):getParser():update("visibility","gone")
		mPhotonView:getParser():getChildView("update_time"):getParser():update("visibility","gone")
		mPhotonView:getParser():getChildView("author_title"):getParser():update("visibility","gone")
		mPhotonView:getParser():getChildView("permission_info"):getParser():update("visibility","gone")
		mPhotonView:getParser():getChildView("permission_link"):getParser():update("visibility","gone")
		mPhotonView:getParser():getChildView("flag_novirus"):getParser():update("visibility","gone")
		mPhotonView:getParser():getChildView("flag_noad"):getParser():update("visibility","gone")
		mPhotonView:getParser():getChildView("flag_txcloud"):getParser():update("visibility","gone")
		mPhotonView:getParser():getChildView("flag_usercare"):getParser():update("visibility","gone")
		mPhotonView:getParser():getChildView("expand_shader"):getParser():update("visibility","visible")
		mPhotonView:getParser():getChildView("expand_icon"):getParser():update("alignparentbottom","false")

		if(binder ~= nil and binder:get('arrow_open_url') ~= nil and binder:get('arrow_open_url') ~= "")then
			mPhotonView:getParser():getChildView("expand_icon"):getParser():update("url","data@arrow_open_url")
		else
			mPhotonView:getParser():getChildView("expand_icon"):getParser():update("image","res@icon_open")
		end

		local isInstall  = mPhotonView:getParser():getBinder():get('isInstall')
        if( isInstall == "1" )then
            if(mPhotonView:getParser():getChildView("expand_icon_up") ~= nil)then
                mPhotonView:getParser():getChildView("expand_icon_up"):getParser():update("visibility","visible")
            end
            if(mPhotonView:getParser():getChildView("expand_icon_up_wz") ~= nil)then
                mPhotonView:getParser():getChildView("expand_icon_up_wz"):getParser():update("visibility","visible")
            end
            mPhotonView:getParser():getChildView("description_container"):getParser():update("visibility","gone")
        end

		cutflag = true

		mJavaBridge:postRun(updateChangeGameListHeight)
	end

end

function setCutFlagState()
	if( cutflag ) then
		mPhotonView:getParser():getChildView("description_txt"):getParser():update("cutflag","true")
	else
		mPhotonView:getParser():getChildView("description_txt"):getParser():update("cutflag","false")
	end
end

function showFlagView()
	local binder = mPhotonView:getParser():getBinder()
	if( binder == nil)
	then
		return
	end

	local flag  = binder:get('flag')

	if( flag == nil)
	then
		return
	end


	local value = 0
	local t = type(flag);
	if t=="number"then
		value = flag
	elseif t=="string"then
		local n = tonumber(flag);
		if n then
			value = n
		end
	end


	mPhotonView:getParser():getChildView("flag_novirus"):getParser():update("visibility","visible")

	mPhotonView:getParser():getChildView("flag_noad"):getParser():update("visibility","visible")
	if(isHaveAd(value))then
		mPhotonView:getParser():getChildView("flag_noad_image"):getParser():update("image","res@icon_3_2")
		mPhotonView:getParser():getChildView("flag_noad_txt"):getParser():update("text","有广告：已通过腾讯手机管家、金山手机毒霸检查")
	else
		mPhotonView:getParser():getChildView("flag_noad_image"):getParser():update("image","res@icon_3_1")
		mPhotonView:getParser():getChildView("flag_noad_txt"):getParser():update("text","无广告：已通过腾讯手机管家、金山手机毒霸检查")
	end


	if(isTencentCloud(value))then
		mPhotonView:getParser():getChildView("flag_txcloud"):getParser():update("visibility","visible")
	end

	if(isHaveUserCare(value))then
		mPhotonView:getParser():getChildView("flag_usercare"):getParser():update("visibility","visible")
	end
end

function isHaveAd(flag)
	local ret = true

	bs = native_bit:_and(flag,3)


	if(bs == 1)then
		ret = false
	end
	return ret
end


function isTencentCloud(flag)
	local ret = false

	bs = native_bit:_and(native_bit:_rshift(flag,21),1)

	if(bs == 1)then
		ret = true
	end
	return ret
end

function isHaveUserCare(flag)
	local ret = false

	bs = native_bit:_and(native_bit:_rshift(flag,14),1)

	if(bs == 1)then
		ret = true
	end
	return ret
end

function concatStr()
	local binder = mPhotonView:getParser():getBinder()

	if( binder == nil)
	then
		return
	end

	local versionName  = binder:get('versionName')
	if( versionName == nil )
	then
		versionName= "未知"
	end

	binder:update('ex_versionName', "版本: " .. versionName)

	local uptimeStr  = binder:get('uptimeStr')
	if( uptimeStr == nil )
	then
		uptimeStr= "未知"
	end

	binder:update('ex_uptimeStr', "更新时间: " .. uptimeStr)

	local author  = binder:get('author')
	if( author == nil )
	then
		author= "未知"
	end

	binder:update('ex_author', "开发者: " .. author)

end

function getStartShadeColor()
	local binder = mPhotonView:getParser():getBinder()

	if( binder == nil)then
		return
	end

	local bgColor  = binder:get('background_color')

	if( bgColor ~= nil ) then
		local startBg = bgColor
		if(string.len(bgColor)==8) then
			startBg = "00"..string.sub(bgColor,3,-1)
		elseif(string.len(bgColor)==6) then
			startBg = "00"..bgColor
		end

		binder:update('ex_start_bg', startBg)
	end
end


--以下是下载面板的逻辑

local subscribeButton = nil
local mSubscribing = false

function makeHomePageDownloadArea()
	local binder = mPhotonView:getParser():getBinder()
    local isHomePage = binder:get('is_home_page_tab')
    local appid      = binder:get('appid')
	-- isHomePage = 0
    
    if (isHomePage == nil or isHomePage == 0 or isHomePage == "0") then
        local downloadArea = mPhotonView:getParser():getChildView("download_area")
        if (downloadArea ~= nil) then
            downloadArea:getParser():update("visibility","gone")
        end
        return
    end

    if (isHomePage == 1 or isHomePage == "1") then
        
        local appInfoArea 	 = mPhotonView:getParser():getChildView("app_info_area")
		local downloadLayout = mPhotonView:getParser():getChildView("intro_wz_layout")    
		local buttonColor 	 = binder:get("button_color")
		
		if (downloadLayout ~= nil) then
			local layoutParams = downloadLayout:getView():getLayoutParams()
			if (layoutParams ~= nil) then
				layoutParams.leftMargin = mJavaBridge:dip2px(9)
			end
		end
		
		if (buttonColor == nil or string.len(buttonColor) == 0 ) then
            buttonColor = "#1d82ff"
		elseif ((string.find(buttonColor,"ffffff")) == nil) and ((string.find(buttonColor,"000000") == nil)) then
			buttonColor = "#1d82ff"
		end
		

        local isSubscribe = binder:get('is_subscribe')
        
        if (isSubscribe ~= nil and (isSubscribe == 1 or isSubscribe == "1")) then
            local downloadButton 	  = mPhotonView:getParser():getChildView("download_button")
			subscribeButton		 	  = mPhotonView:getParser():getChildView("subscribe_button")
			local subscribeDrsc  	  = binder:get("subsceibe_desc")
			local commentNumTextView  = mPhotonView:getParser():getChildView("comment_num")

            -- local typeAreaCliskListener      = luajava.createProxy('android.view.View$OnClickListener',Send)

            if (downloadButton ~= nil) then
                downloadButton:getParser():update("visibility","gone")	
            end

            local gradientDrawable = luajava.newInstance('android.graphics.drawable.GradientDrawable')
            local Color            = luajava.bindClass('android.graphics.Color')

            if (gradientDrawable ~= nil and subscribeButton ~= nil) then
                gradientDrawable:setCornerRadius(mJavaBridge:dip2px(2))
                gradientDrawable:setStroke(2, Color:parseColor(buttonColor))
                gradientDrawable:setCornerRadius(mJavaBridge:dip2px(2))
                subscribeButton:getView():setBackgroundDrawable(gradientDrawable)
				subscribeButton:getView():setTextColor(Color:parseColor(buttonColor))
			end
			
			if (commentNumTextView ~= nil and subscribeDrsc ~= nil ) then
				commentNumTextView:getView():setText(subscribeDrsc)
			end
           

			local hasSubscribe =  binder:get('has_subscribe')
			-- hasSubscribe = 0
			
            if (hasSubscribe ~= nil and (hasSubscribe == 1 or hasSubscribe == "1")) then
                makeButtonGray(subscribeButton:getView())
            else 
                subscribeButton:getView():setText("预约")
            end
            
        end

        if (isSubscribe == nil or isSubscribe == 0 or isSubscribe == "0") then
            local subscribeButton = mPhotonView:getParser():getChildView("subscribe_button")
            local downloadButton = mPhotonView:getParser():getChildView("download_button")

            if (subscribeButton ~= nil) then
                subscribeButton:getParser():update("visibility","gone")	
            end

            if (downloadButton ~= nil) then
                -- downloadButton:getView():setBackgroundStyle(buttonColor)
                downloadButton:getView():setTextViewStyle(buttonColor)
                downloadButton:getView():setCustomShapeStyle(buttonColor)
                downloadButton:getView():setCustomProgressStyle(buttonColor)
            end

        end

        if (appInfoArea ~= nil) then
			appInfoArea:getParser():update("visibility","gone")
        end

        local commentArea = mPhotonView:getParser():getChildView("comment_container_wz")
        if (commentArea ~= nil) then
            commentArea:getParser():update("visibility","gone")	
        end

        local expandIcon = mPhotonView:getParser():getChildView("expand_icon_up_wz")
        if (expandIcon ~= nil) then
            expandIcon:getParser():update("visibility","gone")
        end
    
    end

end

function makeButtonGray(button)
    if (button == nil) then
        return
    end

    local gradientDrawable = luajava.newInstance('android.graphics.drawable.GradientDrawable')
    local Color            = luajava.bindClass('android.graphics.Color')
	
	if (gradientDrawable ~= nil ) then
		button:setBackgroundColor(Color:parseColor("#66979797"))
		button:setTextColor(Color:parseColor("#a6ffffff"))
		gradientDrawable:setColor(Color:parseColor("#66979797"))
		gradientDrawable:setStroke(2, Color:parseColor("#66ffffff"))
		gradientDrawable:setCornerRadius(mJavaBridge:dip2px(2))
		button:setBackgroundDrawable(gradientDrawable)
		button:setClickable(false)
		button:setText("已预约")
	end

end


function onRequestSucceed(viewNameList, dataList)
    local updateData = {}
    updateData["value"] = "预约成功"
	mPhotonView:getParser():getTaskCenter():getActionRunner():run("toastaction",updateData,updateData)
	
	if (subscribeButton ~= nil) then
		makeButtonGray(subscribeButton:getView())
	end
end

function onRequestFailed()
    local updateData = {}
    updateData["value"] = "预约失败"
	mPhotonView:getParser():getTaskCenter():getActionRunner():run("toastaction",updateData,updateData)
end

function sendSubscribe()
	local params = {}
    params["appid"] = mPhotonView:getParser():getBinder():get("appid")
	params["scene"] = mPhotonView:getParser():getBinder():get("scene")
    
	if not mSubscribing then
		mSubscribing = true
		mJavaBridge:request(2, params, onRequestListener)
	end
end

function onRequestListener(succeed, viewNameList, dataList)
	mSubscribing = false
	if( succeed ) then
		onRequestSucceed(viewNameList, dataList)
	else
		onRequestFailed()
	end
end

local CHANGE_GAME_BAR_HEIGHT = 52
local BANNER_HEIGHT = mPhotonView:getParser():getScreenWidth() * 0.637
local BANNER_MARGIN_TOP = 62

function set_flat_bar()
	-- 对沉浸式状态栏进行适配
	if not mJavaBridge:isFlatStyleBar() then
		return
	end
    local statusHeight = mJavaBridge:getStatusBarHeight()
    local statusHeightDp =  mJavaBridge:px2dip(statusHeight)

	local headerBanner = mPhotonView:getParser():getChildView("header")

	-- 根据状态栏高度增加banner的高度
	local bannerHeight = BANNER_HEIGHT + statusHeight
	headerBanner:getParser():update("height",mJavaBridge:px2dip(bannerHeight))
	local bannerMarginTop = BANNER_MARGIN_TOP + statusHeightDp
	local bannermargin = "0," .. bannerMarginTop .. ",0,0"
	headerBanner:getParser():update("bannermargin",bannermargin)

	-- 计算切换游戏栏的高度
	local statusDp = statusHeightDp + CHANGE_GAME_BAR_HEIGHT
    local bar = mPhotonView:getParser():getChildView("change_game_bar")
    
	--  修改切换游戏栏高度
	-- bar:getParser():update("height",statusDp)
end



